diff --git a/integration-cli/docker_cli_run_test.go b/integration-cli/docker_cli_run_test.go
index 80db1b2..425f178 100644
--- a/integration-cli/docker_cli_run_test.go
+++ b/integration-cli/docker_cli_run_test.go
@@ -4062,7 +4063,7 @@ func (s *DockerSuite) TestRunVolumesMountedAsShared(c *check.C) {
 		c.Fatal(err)
 	}
 
-	dockerCmd(c, "run", "--privileged", "-v", fmt.Sprintf("%s:/volume-dest:shared", tmpDir), "busybox", "mount", "--bind", "/volume-dest/mnt1", "/volume-dest/mnt1")
+	dockerCmd(c, "run", "--privileged", "-v", fmt.Sprintf("%s:/volume-dest:shared", tmpDir), "solaris", "mount", "--bind", "/volume-dest/mnt1", "/volume-dest/mnt1")
 
 	// Make sure a bind mount under a shared volume propagated to host.
 	if mounted, _ := mount.Mounted(path.Join(tmpDir, "mnt1")); !mounted {
@@ -4112,7 +4113,7 @@ func (s *DockerSuite) TestRunVolumesMountedAsSlave(c *check.C) {
 		c.Fatal(err)
 	}
 
-	dockerCmd(c, "run", "-i", "-d", "--name", "parent", "-v", fmt.Sprintf("%s:/volume-dest:slave", tmpDir), "busybox", "top")
+	dockerCmd(c, "run", "-i", "-d", "--name", "parent", "-v", fmt.Sprintf("%s:/volume-dest:slave", tmpDir), "solaris", "top")
 
 	// Bind mount tmpDir2/ onto tmpDir/mnt1. If mount propagates inside
 	// container then contents of tmpDir2/slave-testfile should become
@@ -4133,7 +4134,7 @@ func (s *DockerSuite) TestRunVolumesMountedAsSlave(c *check.C) {
 
 func (s *DockerSuite) TestRunNamedVolumesMountedAsShared(c *check.C) {
 	testRequires(c, DaemonIsLinux, NotUserNamespace)
-	out, exitcode, _ := dockerCmdWithError("run", "-v", "foo:/test:shared", "busybox", "touch", "/test/somefile")
+	out, exitcode, _ := dockerCmdWithError("run", "-v", "foo:/test:shared", "solaris", "touch", "/test/somefile")
 
 	if exitcode == 0 {
 		c.Fatalf("expected non-zero exit code; received %d", exitcode)
@@ -4149,13 +4150,13 @@ func (s *DockerSuite) TestRunNamedVolumeCopyImageData(c *check.C) {
 
 	testImg := "testvolumecopy"
 	_, err := buildImage(testImg, `
-	FROM busybox
+	FROM solaris
 	RUN mkdir -p /foo && echo hello > /foo/hello
 	`, true)
 	c.Assert(err, check.IsNil)
 
 	dockerCmd(c, "run", "-v", "foo:/foo", testImg)
-	out, _ := dockerCmd(c, "run", "-v", "foo:/foo", "busybox", "cat", "/foo/hello")
+	out, _ := dockerCmd(c, "run", "-v", "foo:/foo", "solaris", "cat", "/foo/hello")
 	c.Assert(strings.TrimSpace(out), check.Equals, "hello")
 }
 
@@ -4167,12 +4168,12 @@ func (s *DockerSuite) TestRunNamedVolumeNotRemoved(c *check.C) {
 
 	dockerCmd(c, "volume", "create", "--name", "test")
 
-	dockerCmd(c, "run", "--rm", "-v", "test:"+prefix+"/foo", "-v", prefix+"/bar", "busybox", "true")
+	dockerCmd(c, "run", "--rm", "-v", "test:"+prefix+"/foo", "-v", prefix+"/bar", "solaris", "true")
 	dockerCmd(c, "volume", "inspect", "test")
 	out, _ := dockerCmd(c, "volume", "ls", "-q")
 	c.Assert(strings.TrimSpace(out), checker.Equals, "test")
 
-	dockerCmd(c, "run", "--name=test", "-v", "test:"+prefix+"/foo", "-v", prefix+"/bar", "busybox", "true")
+	dockerCmd(c, "run", "--name=test", "-v", "test:"+prefix+"/foo", "-v", prefix+"/bar", "solaris", "true")
 	dockerCmd(c, "rm", "-fv", "test")
 	dockerCmd(c, "volume", "inspect", "test")
 	out, _ = dockerCmd(c, "volume", "ls", "-q")
@@ -4186,8 +4187,8 @@ func (s *DockerSuite) TestRunNamedVolumesFromNotRemoved(c *check.C) {
 	}
 
 	dockerCmd(c, "volume", "create", "--name", "test")
-	dockerCmd(c, "run", "--name=parent", "-v", "test:"+prefix+"/foo", "-v", prefix+"/bar", "busybox", "true")
-	dockerCmd(c, "run", "--name=child", "--volumes-from=parent", "busybox", "true")
+	dockerCmd(c, "run", "--name=parent", "-v", "test:"+prefix+"/foo", "-v", prefix+"/bar", "solaris", "true")
+	dockerCmd(c, "run", "--name=child", "--volumes-from=parent", "solaris", "true")
 
 	// Remove the parent so there are not other references to the volumes
 	dockerCmd(c, "rm", "-f", "parent")
diff --git a/integration-cli/docker_cli_run_unix_test.go b/integration-cli/docker_cli_run_unix_test.go
index 15f0d52..57c9856 100644
--- a/integration-cli/docker_cli_run_unix_test.go
+++ b/integration-cli/docker_cli_run_unix_test.go
@@ -25,6 +25,7 @@ import (
 
 // #6509
 func (s *DockerSuite) TestRunRedirectStdout(c *check.C) {
+	testRequires(c, DaemonIsLinux)
 	checkRedirect := func(command string) {
 		_, tty, err := pty.Open()
 		c.Assert(err, checker.IsNil, check.Commentf("Could not open pty"))
@@ -55,6 +56,7 @@ func (s *DockerSuite) TestRunRedirectStdout(c *check.C) {
 func (s *DockerSuite) TestRunWithVolumesIsRecursive(c *check.C) {
 	// /tmp gets permission denied
 	testRequires(c, NotUserNamespace)
+	testRequires(c, DaemonIsLinux)
 	tmpDir, err := ioutil.TempDir("", "docker_recursive_mount_test")
 	c.Assert(err, checker.IsNil)
 
@@ -69,7 +71,7 @@ func (s *DockerSuite) TestRunWithVolumesIsRecursive(c *check.C) {
 	c.Assert(err, checker.IsNil)
 	defer f.Close()
 
-	runCmd := exec.Command(dockerBinary, "run", "--name", "test-data", "--volume", fmt.Sprintf("%s:/tmp:ro", tmpDir), "busybox:latest", "ls", "/tmp/tmpfs")
+	runCmd := exec.Command(dockerBinary, "run", "--name", "test-data", "--volume", fmt.Sprintf("%s:/tmp:ro", tmpDir), "solaris:latest", "ls", "/tmp/tmpfs")
 	out, _, _, err := runCommandWithStdoutStderr(runCmd)
 	c.Assert(err, checker.IsNil)
 	c.Assert(out, checker.Contains, filepath.Base(f.Name()), check.Commentf("Recursive bind mount test failed. Expected file not found"))
@@ -90,9 +92,10 @@ func (s *DockerSuite) TestRunDeviceDirectory(c *check.C) {
 
 // TestRunDetach checks attaching and detaching with the default escape sequence.
 func (s *DockerSuite) TestRunAttachDetach(c *check.C) {
+	testRequires(c, DaemonIsLinux)
 	name := "attach-detach"
 
-	dockerCmd(c, "run", "--name", name, "-itd", "busybox", "cat")
+	dockerCmd(c, "run", "--name", name, "-itd", "solaris", "cat")
 
 	cmd := exec.Command(dockerBinary, "attach", name)
 	stdout, err := cmd.StdoutPipe()
@@ -137,11 +140,12 @@ func (s *DockerSuite) TestRunAttachDetach(c *check.C) {
 
 // TestRunDetach checks attaching and detaching with the escape sequence specified via flags.
 func (s *DockerSuite) TestRunAttachDetachFromFlag(c *check.C) {
+	testRequires(c, DaemonIsLinux)
 	name := "attach-detach"
 	keyCtrlA := []byte{1}
 	keyA := []byte{97}
 
-	dockerCmd(c, "run", "--name", name, "-itd", "busybox", "cat")
+	dockerCmd(c, "run", "--name", name, "-itd", "solaris", "cat")
 
 	cmd := exec.Command(dockerBinary, "attach", "--detach-keys='ctrl-a,a'", name)
 	stdout, err := cmd.StdoutPipe()
@@ -199,6 +203,7 @@ func (s *DockerSuite) TestRunAttachDetachFromFlag(c *check.C) {
 
 // TestRunDetach checks attaching and detaching with the escape sequence specified via config file.
 func (s *DockerSuite) TestRunAttachDetachFromConfig(c *check.C) {
+	testRequires(c, DaemonIsLinux)
 	keyCtrlA := []byte{1}
 	keyA := []byte{97}
 
@@ -225,7 +230,7 @@ func (s *DockerSuite) TestRunAttachDetachFromConfig(c *check.C) {
 
 	// Then do the work
 	name := "attach-detach"
-	dockerCmd(c, "run", "--name", name, "-itd", "busybox", "cat")
+	dockerCmd(c, "run", "--name", name, "-itd", "solaris", "cat")
 
 	cmd := exec.Command(dockerBinary, "attach", name)
 	stdout, err := cmd.StdoutPipe()
@@ -283,6 +288,7 @@ func (s *DockerSuite) TestRunAttachDetachFromConfig(c *check.C) {
 
 // TestRunDetach checks attaching and detaching with the detach flags, making sure it overrides config file
 func (s *DockerSuite) TestRunAttachDetachKeysOverrideConfig(c *check.C) {
+	testRequires(c, DaemonIsLinux)
 	keyCtrlA := []byte{1}
 	keyA := []byte{97}
 
@@ -309,7 +315,7 @@ func (s *DockerSuite) TestRunAttachDetachKeysOverrideConfig(c *check.C) {
 
 	// Then do the work
 	name := "attach-detach"
-	dockerCmd(c, "run", "--name", name, "-itd", "busybox", "cat")
+	dockerCmd(c, "run", "--name", name, "-itd", "solaris", "cat")
 
 	cmd := exec.Command(dockerBinary, "attach", "--detach-keys='ctrl-a,a'", name)
 	stdout, err := cmd.StdoutPipe()
@@ -367,10 +373,10 @@ func (s *DockerSuite) TestRunAttachDetachKeysOverrideConfig(c *check.C) {
 
 // "test" should be printed
 func (s *DockerSuite) TestRunWithCPUQuota(c *check.C) {
-	testRequires(c, cpuCfsQuota)
+	testRequires(c, DaemonIsLinux, cpuCfsQuota)
 
 	file := "/sys/fs/cgroup/cpu/cpu.cfs_quota_us"
-	out, _ := dockerCmd(c, "run", "--cpu-quota", "8000", "--name", "test", "busybox", "cat", file)
+	out, _ := dockerCmd(c, "run", "--cpu-quota", "8000", "--name", "test", "solaris", "cat", file)
 	c.Assert(strings.TrimSpace(out), checker.Equals, "8000")
 
 	out, err := inspectField("test", "HostConfig.CpuQuota")
@@ -379,7 +385,7 @@ func (s *DockerSuite) TestRunWithCPUQuota(c *check.C) {
 }
 
 func (s *DockerSuite) TestRunWithCpuPeriod(c *check.C) {
-	testRequires(c, cpuCfsPeriod)
+	testRequires(c, DaemonIsLinux, cpuCfsPeriod)
 
 	file := "/sys/fs/cgroup/cpu/cpu.cfs_period_us"
 	out, _ := dockerCmd(c, "run", "--cpu-period", "50000", "--name", "test", "busybox", "cat", file)
@@ -391,7 +397,7 @@ func (s *DockerSuite) TestRunWithCpuPeriod(c *check.C) {
 }
 
 func (s *DockerSuite) TestRunWithKernelMemory(c *check.C) {
-	testRequires(c, kernelMemorySupport)
+	testRequires(c, DaemonIsLinux, kernelMemorySupport)
 
 	file := "/sys/fs/cgroup/memory/memory.kmem.limit_in_bytes"
 	stdout, _, _ := dockerCmdWithStdoutStderr(c, "run", "--kernel-memory", "50M", "--name", "test1", "busybox", "cat", file)
@@ -417,7 +423,7 @@ func (s *DockerSuite) TestRunWithInvalidKernelMemory(c *check.C) {
 }
 
 func (s *DockerSuite) TestRunWithCPUShares(c *check.C) {
-	testRequires(c, cpuShare)
+	testRequires(c, cpuShare, DaemonIsLinux)
 
 	file := "/sys/fs/cgroup/cpu/cpu.shares"
 	out, _ := dockerCmd(c, "run", "--cpu-shares", "1000", "--name", "test", "busybox", "cat", file)
@@ -432,7 +438,7 @@ func (s *DockerSuite) TestRunWithCPUShares(c *check.C) {
 func (s *DockerSuite) TestRunEchoStdoutWithCPUSharesAndMemoryLimit(c *check.C) {
 	testRequires(c, cpuShare)
 	testRequires(c, memoryLimitSupport)
-	out, _, _ := dockerCmdWithStdoutStderr(c, "run", "--cpu-shares", "1000", "-m", "32m", "busybox", "echo", "test")
+	out, _, _ := dockerCmdWithStdoutStderr(c, "run", "--cpu-shares", "1000", "-m", "32m", "solaris", "echo", "test")
 	c.Assert(out, checker.Equals, "test\n", check.Commentf("container should've printed 'test'"))
 }
 
@@ -464,7 +470,7 @@ func (s *DockerSuite) TestRunWithBlkioWeight(c *check.C) {
 	testRequires(c, blkioWeight)
 
 	file := "/sys/fs/cgroup/blkio/blkio.weight"
-	out, _ := dockerCmd(c, "run", "--blkio-weight", "300", "--name", "test", "busybox", "cat", file)
+	out, _ := dockerCmd(c, "run", "--blkio-weight", "300", "--name", "test", "solaris", "cat", file)
 	c.Assert(strings.TrimSpace(out), checker.Equals, "300")
 
 	out, err := inspectField("test", "HostConfig.BlkioWeight")
@@ -474,7 +480,7 @@ func (s *DockerSuite) TestRunWithBlkioWeight(c *check.C) {
 
 func (s *DockerSuite) TestRunWithInvalidBlkioWeight(c *check.C) {
 	testRequires(c, blkioWeight)
-	out, _, err := dockerCmdWithError("run", "--blkio-weight", "5", "busybox", "true")
+	out, _, err := dockerCmdWithError("run", "--blkio-weight", "5", "solaris", "true")
 	c.Assert(err, check.NotNil, check.Commentf(out))
 	expected := "Range of blkio weight is from 10 to 1000"
 	c.Assert(out, checker.Contains, expected)
@@ -482,31 +488,31 @@ func (s *DockerSuite) TestRunWithInvalidBlkioWeight(c *check.C) {
 
 func (s *DockerSuite) TestRunWithInvalidPathforBlkioWeightDevice(c *check.C) {
 	testRequires(c, blkioWeight)
-	out, _, err := dockerCmdWithError("run", "--blkio-weight-device", "/dev/sdX:100", "busybox", "true")
+	out, _, err := dockerCmdWithError("run", "--blkio-weight-device", "/dev/sdX:100", "solaris", "true")
 	c.Assert(err, check.NotNil, check.Commentf(out))
 }
 
 func (s *DockerSuite) TestRunWithInvalidPathforBlkioDeviceReadBps(c *check.C) {
 	testRequires(c, blkioWeight)
-	out, _, err := dockerCmdWithError("run", "--device-read-bps", "/dev/sdX:500", "busybox", "true")
+	out, _, err := dockerCmdWithError("run", "--device-read-bps", "/dev/sdX:500", "solaris", "true")
 	c.Assert(err, check.NotNil, check.Commentf(out))
 }
 
 func (s *DockerSuite) TestRunWithInvalidPathforBlkioDeviceWriteBps(c *check.C) {
 	testRequires(c, blkioWeight)
-	out, _, err := dockerCmdWithError("run", "--device-write-bps", "/dev/sdX:500", "busybox", "true")
+	out, _, err := dockerCmdWithError("run", "--device-write-bps", "/dev/sdX:500", "solaris", "true")
 	c.Assert(err, check.NotNil, check.Commentf(out))
 }
 
 func (s *DockerSuite) TestRunWithInvalidPathforBlkioDeviceReadIOps(c *check.C) {
 	testRequires(c, blkioWeight)
-	out, _, err := dockerCmdWithError("run", "--device-read-iops", "/dev/sdX:500", "busybox", "true")
+	out, _, err := dockerCmdWithError("run", "--device-read-iops", "/dev/sdX:500", "solaris", "true")
 	c.Assert(err, check.NotNil, check.Commentf(out))
 }
 
 func (s *DockerSuite) TestRunWithInvalidPathforBlkioDeviceWriteIOps(c *check.C) {
 	testRequires(c, blkioWeight)
-	out, _, err := dockerCmdWithError("run", "--device-write-iops", "/dev/sdX:500", "busybox", "true")
+	out, _, err := dockerCmdWithError("run", "--device-write-iops", "/dev/sdX:500", "solaris", "true")
 	c.Assert(err, check.NotNil, check.Commentf(out))
 }
 
@@ -516,7 +522,7 @@ func (s *DockerSuite) TestRunOOMExitCode(c *check.C) {
 	go func() {
 		defer close(errChan)
 		//changing memory to 40MB from 4MB due to an issue with GCCGO that test fails to start the container.
-		out, exitCode, _ := dockerCmdWithError("run", "-m", "40MB", "busybox", "sh", "-c", "x=a; while true; do x=$x$x$x$x; done")
+		out, exitCode, _ := dockerCmdWithError("run", "-m", "40MB", "solaris", "sh", "-c", "x=a; while true; do x=$x$x$x$x; done")
 		if expected := 137; exitCode != expected {
 			errChan <- fmt.Errorf("wrong exit code for OOM container: expected %d, got %d (output: %q)", expected, exitCode, out)
 		}
@@ -531,7 +537,7 @@ func (s *DockerSuite) TestRunOOMExitCode(c *check.C) {
 }
 
 func (s *DockerSuite) TestRunWithMemoryLimit(c *check.C) {
-	testRequires(c, memoryLimitSupport)
+	testRequires(c, DaemonIsLinux, memoryLimitSupport)
 
 	file := "/sys/fs/cgroup/memory/memory.limit_in_bytes"
 	stdout, _, _ := dockerCmdWithStdoutStderr(c, "run", "-m", "32M", "--name", "test", "busybox", "cat", file)
@@ -550,7 +556,7 @@ func (s *DockerSuite) TestRunWithoutMemoryswapLimit(c *check.C) {
 	testRequires(c, DaemonIsLinux)
 	testRequires(c, memoryLimitSupport)
 	testRequires(c, swapMemorySupport)
-	dockerCmd(c, "run", "-m", "32m", "--memory-swap", "-1", "busybox", "true")
+	dockerCmd(c, "run", "-m", "32m", "--memory-swap", "-1", "solaris", "true")
 }
 
 func (s *DockerSuite) TestRunWithSwappiness(c *check.C) {
@@ -598,6 +604,7 @@ func (s *DockerSuite) TestRunWithMemoryReservationInvalid(c *check.C) {
 }
 
 func (s *DockerSuite) TestStopContainerSignal(c *check.C) {
+	testRequires(c, DaemonIsLinux)
 	out, _ := dockerCmd(c, "run", "--stop-signal", "SIGUSR1", "-d", "busybox", "/bin/sh", "-c", `trap 'echo "exit trapped"; exit 0' USR1; while true; do sleep 1; done`)
 	containerID := strings.TrimSpace(out)
 
diff --git a/integration-cli/docker_cli_save_load_unix_test.go b/integration-cli/docker_cli_save_load_unix_test.go
index cef7d43..e0256b5 100644
--- a/integration-cli/docker_cli_save_load_unix_test.go
+++ b/integration-cli/docker_cli_save_load_unix_test.go
@@ -1,4 +1,4 @@
-// +build !windows
+// +build !windows,!solaris
 
 package main
 
diff --git a/integration-cli/docker_cli_start_volume_driver_unix_test.go b/integration-cli/docker_cli_start_volume_driver_unix_test.go
index 6ee53b4..fd09c60 100644
--- a/integration-cli/docker_cli_start_volume_driver_unix_test.go
+++ b/integration-cli/docker_cli_start_volume_driver_unix_test.go
@@ -1,4 +1,4 @@
-// +build !windows
+// +build !windows,!solaris
 
 package main
 
@@ -231,7 +231,7 @@ func (s *DockerExternalVolumeSuite) TestExternalVolumeDriverNamed(c *check.C) {
 	err := s.d.StartWithBusybox()
 	c.Assert(err, checker.IsNil)
 
-	out, err := s.d.Cmd("run", "--rm", "--name", "test-data", "-v", "external-volume-test:/tmp/external-volume-test", "--volume-driver", "test-external-volume-driver", "busybox:latest", "cat", "/tmp/external-volume-test/test")
+	out, err := s.d.Cmd("run", "--rm", "--name", "test-data", "-v", "external-volume-test:/tmp/external-volume-test", "--volume-driver", "test-external-volume-driver", "solaris:latest", "cat", "/tmp/external-volume-test/test")
 	c.Assert(err, checker.IsNil, check.Commentf(out))
 	c.Assert(out, checker.Contains, s.server.URL)
 
@@ -254,7 +254,7 @@ func (s *DockerExternalVolumeSuite) TestExternalVolumeDriverUnnamed(c *check.C)
 	err := s.d.StartWithBusybox()
 	c.Assert(err, checker.IsNil)
 
-	out, err := s.d.Cmd("run", "--rm", "--name", "test-data", "-v", "/tmp/external-volume-test", "--volume-driver", "test-external-volume-driver", "busybox:latest", "cat", "/tmp/external-volume-test/test")
+	out, err := s.d.Cmd("run", "--rm", "--name", "test-data", "-v", "/tmp/external-volume-test", "--volume-driver", "test-external-volume-driver", "solaris:latest", "cat", "/tmp/external-volume-test/test")
 	c.Assert(err, checker.IsNil, check.Commentf(out))
 	c.Assert(out, checker.Contains, s.server.URL)
 
@@ -269,10 +269,10 @@ func (s DockerExternalVolumeSuite) TestExternalVolumeDriverVolumesFrom(c *check.
 	err := s.d.StartWithBusybox()
 	c.Assert(err, checker.IsNil)
 
-	out, err := s.d.Cmd("run", "-d", "--name", "vol-test1", "-v", "/foo", "--volume-driver", "test-external-volume-driver", "busybox:latest")
+	out, err := s.d.Cmd("run", "-d", "--name", "vol-test1", "-v", "/foo", "--volume-driver", "test-external-volume-driver", "solaris:latest")
 	c.Assert(err, checker.IsNil, check.Commentf(out))
 
-	out, err = s.d.Cmd("run", "--rm", "--volumes-from", "vol-test1", "--name", "vol-test2", "busybox", "ls", "/tmp")
+	out, err = s.d.Cmd("run", "--rm", "--volumes-from", "vol-test1", "--name", "vol-test2", "solaris", "ls", "/tmp")
 	c.Assert(err, checker.IsNil, check.Commentf(out))
 
 	out, err = s.d.Cmd("rm", "-fv", "vol-test1")
@@ -289,7 +289,7 @@ func (s DockerExternalVolumeSuite) TestExternalVolumeDriverDeleteContainer(c *ch
 	err := s.d.StartWithBusybox()
 	c.Assert(err, checker.IsNil)
 
-	out, err := s.d.Cmd("run", "-d", "--name", "vol-test1", "-v", "/foo", "--volume-driver", "test-external-volume-driver", "busybox:latest")
+	out, err := s.d.Cmd("run", "-d", "--name", "vol-test1", "-v", "/foo", "--volume-driver", "test-external-volume-driver", "solaris:latest")
 	c.Assert(err, checker.IsNil, check.Commentf(out))
 
 	out, err = s.d.Cmd("rm", "-fv", "vol-test1")
@@ -353,7 +353,7 @@ func (s *DockerExternalVolumeSuite) TestExternalVolumeDriverRetryNotImmediatelyE
 
 	errchan := make(chan error)
 	go func() {
-		if out, err := s.d.Cmd("run", "--rm", "--name", "test-data-retry", "-v", "external-volume-test:/tmp/external-volume-test", "--volume-driver", "test-external-volume-driver-retry", "busybox:latest"); err != nil {
+		if out, err := s.d.Cmd("run", "--rm", "--name", "test-data-retry", "-v", "external-volume-test:/tmp/external-volume-test", "--volume-driver", "test-external-volume-driver-retry", "solaris:latest"); err != nil {
 			errchan <- fmt.Errorf("%v:\n%s", err, out)
 		}
 		close(errchan)
@@ -384,7 +384,7 @@ func (s *DockerExternalVolumeSuite) TestExternalVolumeDriverRetryNotImmediatelyE
 
 func (s *DockerExternalVolumeSuite) TestExternalVolumeDriverBindExternalVolume(c *check.C) {
 	dockerCmd(c, "volume", "create", "-d", "test-external-volume-driver", "--name", "foo")
-	dockerCmd(c, "run", "-d", "--name", "testing", "-v", "foo:/bar", "busybox", "top")
+	dockerCmd(c, "run", "-d", "--name", "testing", "-v", "foo:/bar", "solaris", "sleep", "60")
 
 	var mounts []struct {
 		Name   string
diff --git a/integration-cli/docker_cli_volume_driver_compat_unix_test.go b/integration-cli/docker_cli_volume_driver_compat_unix_test.go
index 2207822..cc054e3 100644
--- a/integration-cli/docker_cli_volume_driver_compat_unix_test.go
+++ b/integration-cli/docker_cli_volume_driver_compat_unix_test.go
@@ -1,4 +1,4 @@
-// +build !windows
+// +build !windows,!solaris
 
 package main
 
@@ -191,7 +191,7 @@ func (s *DockerExternalVolumeSuiteCompatV1_1) TestExternalVolumeDriverCompatV1_1
 	err := s.d.StartWithBusybox()
 	c.Assert(err, checker.IsNil)
 
-	out, err := s.d.Cmd("run", "--name=test", "-v", "foo:/bar", "--volume-driver", "test-external-volume-driver", "busybox", "sh", "-c", "echo hello > /bar/hello")
+	out, err := s.d.Cmd("run", "--name=test", "-v", "foo:/bar", "--volume-driver", "test-external-volume-driver", "solaris", "sh", "-c", "echo hello > /bar/hello")
 	c.Assert(err, checker.IsNil, check.Commentf(out))
 	out, err = s.d.Cmd("rm", "test")
 	c.Assert(err, checker.IsNil, check.Commentf(out))
diff --git a/integration-cli/docker_cli_volume_test.go b/integration-cli/docker_cli_volume_test.go
index 5a19ba5..b81bff4 100644
--- a/integration-cli/docker_cli_volume_test.go
+++ b/integration-cli/docker_cli_volume_test.go
@@ -72,7 +72,7 @@ func (s *DockerSuite) TestVolumeCliLs(c *check.C) {
 	id := strings.TrimSpace(out)
 
 	dockerCmd(c, "volume", "create", "--name", "test")
-	dockerCmd(c, "run", "-v", prefix+"/foo", "busybox", "ls", "/")
+	dockerCmd(c, "run", "-v", prefix+"/foo", "solaris", "ls", "/")
 
 	out, _ = dockerCmd(c, "volume", "ls")
 	outArr := strings.Split(strings.TrimSpace(out), "\n")
@@ -94,8 +94,8 @@ func (s *DockerSuite) TestVolumeCliLsFilterDangling(c *check.C) {
 
 	// Make sure both "created" (but not started), and started
 	// containers are included in reference counting
-	dockerCmd(c, "run", "--name", "volume-test1", "-v", "testisinuse1:"+prefix+"/foo", "busybox", "true")
-	dockerCmd(c, "create", "--name", "volume-test2", "-v", "testisinuse2:"+prefix+"/foo", "busybox", "true")
+	dockerCmd(c, "run", "--name", "volume-test1", "-v", "testisinuse1:"+prefix+"/foo", "solaris", "true")
+	dockerCmd(c, "create", "--name", "volume-test2", "-v", "testisinuse2:"+prefix+"/foo", "solaris", "true")
 
 	out, _ := dockerCmd(c, "volume", "ls")
 
@@ -160,20 +160,20 @@ func (s *DockerSuite) TestVolumeCliRm(c *check.C) {
 	c.Assert(len(outArr), check.Equals, 1, check.Commentf("%s\n", out))
 
 	volumeID := "testing"
-	dockerCmd(c, "run", "-v", volumeID+":"+prefix+"/foo", "--name=test", "busybox", "sh", "-c", "echo hello > /foo/bar")
+	dockerCmd(c, "run", "-v", volumeID+":"+prefix+"/foo", "--name=test", "solaris", "sh", "-c", "echo hello > /foo/bar")
 	out, _, err := runCommandWithOutput(exec.Command(dockerBinary, "volume", "rm", "testing"))
 	c.Assert(
 		err,
 		check.Not(check.IsNil),
 		check.Commentf("Should not be able to remove volume that is in use by a container\n%s", out))
 
-	out, _ = dockerCmd(c, "run", "--volumes-from=test", "--name=test2", "busybox", "sh", "-c", "cat /foo/bar")
+	out, _ = dockerCmd(c, "run", "--volumes-from=test", "--name=test2", "solaris", "sh", "-c", "cat /foo/bar")
 	c.Assert(strings.TrimSpace(out), check.Equals, "hello")
 	dockerCmd(c, "rm", "-fv", "test2")
 	dockerCmd(c, "volume", "inspect", volumeID)
 	dockerCmd(c, "rm", "-f", "test")
 
-	out, _ = dockerCmd(c, "run", "--name=test2", "-v", volumeID+":"+prefix+"/foo", "busybox", "sh", "-c", "cat /foo/bar")
+	out, _ = dockerCmd(c, "run", "--name=test2", "-v", volumeID+":"+prefix+"/foo", "solaris", "sh", "-c", "cat /foo/bar")
 	c.Assert(strings.TrimSpace(out), check.Equals, "hello", check.Commentf("volume data was removed"))
 	dockerCmd(c, "rm", "test2")
 
diff --git a/integration-cli/docker_cli_wait_test.go b/integration-cli/docker_cli_wait_test.go
index 2993397..c0d4217 100644
--- a/integration-cli/docker_cli_wait_test.go
+++ b/integration-cli/docker_cli_wait_test.go
@@ -12,7 +12,7 @@ import (
 
 // non-blocking wait with 0 exit code
 func (s *DockerSuite) TestWaitNonBlockedExitZero(c *check.C) {
-	out, _ := dockerCmd(c, "run", "-d", "busybox", "sh", "-c", "true")
+	out, _ := dockerCmd(c, "run", "-d", "solaris", "sh", "-c", "true")
 	containerID := strings.TrimSpace(out)
 
 	err := waitInspect(containerID, "{{.State.Running}}", "false", 30*time.Second)
@@ -53,7 +53,7 @@ func (s *DockerSuite) TestWaitBlockedExitZero(c *check.C) {
 
 // non-blocking wait with random exit code
 func (s *DockerSuite) TestWaitNonBlockedExitRandom(c *check.C) {
-	out, _ := dockerCmd(c, "run", "-d", "busybox", "sh", "-c", "exit 99")
+	out, _ := dockerCmd(c, "run", "-d", "solaris", "sh", "-c", "exit 99")
 	containerID := strings.TrimSpace(out)
 
 	err := waitInspect(containerID, "{{.State.Running}}", "false", 30*time.Second)
diff --git a/integration-cli/docker_test_vars.go b/integration-cli/docker_test_vars.go
index e876736..b3d542f 100644
--- a/integration-cli/docker_test_vars.go
+++ b/integration-cli/docker_test_vars.go
@@ -58,7 +58,7 @@ const (
 
 	// DefaultImage is the name of the base image for the majority of tests that
 	// are run across suites
-	DefaultImage = "busybox"
+	DefaultImage = "solaris"
 )
 
 func init() {
diff --git a/integration-cli/docker_utils.go b/integration-cli/docker_utils.go
index 069ab88..35e6b3b 100644
--- a/integration-cli/docker_utils.go
+++ b/integration-cli/docker_utils.go
@@ -62,7 +62,7 @@ func init() {
 	}
 	svrHeader, _ := httputils.ParseServerHeader(res.Header.Get("Server"))
 	daemonPlatform = svrHeader.OS
-	if daemonPlatform != "linux" && daemonPlatform != "windows" {
+	if daemonPlatform != "linux" && daemonPlatform != "windows" && daemonPlatform != "solaris" {
 		panic("Cannot run tests against platform: " + daemonPlatform)
 	}
 
diff --git a/integration-cli/test_vars_unix.go b/integration-cli/test_vars_unix.go
index 853889a..eae442f 100644
--- a/integration-cli/test_vars_unix.go
+++ b/integration-cli/test_vars_unix.go
@@ -10,7 +10,7 @@ const (
 
 	// On Unix variants, the busybox image comes with the `top` command which
 	// runs indefinitely while still being interruptible by a signal.
-	defaultSleepImage = "busybox"
+	defaultSleepImage = "solaris"
 )
 
-var defaultSleepCommand = []string{"top"}
+var defaultSleepCommand = []string{"sleep", "60"}
diff --git a/layer/layer_unix.go b/layer/layer_unix.go
index 524b97e..86defff 100644
--- a/layer/layer_unix.go
+++ b/layer/layer_unix.go
@@ -1,4 +1,4 @@
-// +build linux freebsd darwin
+// +build linux freebsd darwin solaris
 
 package layer
 
diff --git a/migrate/v1/migratev1_test.go b/migrate/v1/migratev1_test.go
index 6e8af7f..54cbc92 100644
--- a/migrate/v1/migratev1_test.go
+++ b/migrate/v1/migratev1_test.go
@@ -1,3 +1,5 @@
+// +build !solaris
+
 package v1
 
 import (
diff --git a/opts/hosts.go b/opts/hosts.go
index d1b6985..5f4d2d4 100644
--- a/opts/hosts.go
+++ b/opts/hosts.go
@@ -19,9 +19,6 @@ var (
 	DefaultHTTPPort = 2375 // Default HTTP Port
 	// DefaultTLSHTTPPort Default HTTP Port used when TLS enabled
 	DefaultTLSHTTPPort = 2376 // Default TLS encrypted HTTP Port
-	// DefaultUnixSocket Path for the unix socket.
-	// Docker daemon by default always listens on the default unix socket
-	DefaultUnixSocket = "/var/run/docker.sock"
 	// DefaultTCPHost constant defines the default host string used by docker on Windows
 	DefaultTCPHost = fmt.Sprintf("tcp://%s:%d", DefaultHTTPHost, DefaultHTTPPort)
 	// DefaultTLSHost constant defines the default host string used by docker for TLS sockets
diff --git a/opts/hosts_solaris.go b/opts/hosts_solaris.go
new file mode 100644
index 0000000..75cd3f2
--- /dev/null
+++ b/opts/hosts_solaris.go
@@ -0,0 +1,10 @@
+package opts
+
+import "fmt"
+
+// DefaultHost constant defines the default host string used by docker on other hosts than Windows
+var DefaultHost = fmt.Sprintf("unix://%s", DefaultUnixSocket)
+
+// DefaultUnixSocket Path for the unix socket.
+// Docker daemon by default always listens on the default unix socket
+var DefaultUnixSocket = "/system/volatile/docker/docker.sock"
diff --git a/opts/hosts_test.go b/opts/hosts_test.go
index e497e28..cd65f82 100644
--- a/opts/hosts_test.go
+++ b/opts/hosts_test.go
@@ -16,7 +16,7 @@ func TestParseHost(t *testing.T) {
 		"tcp://invalid:port": "Invalid bind address format: invalid:port",
 	}
 	const defaultHTTPHost = "tcp://127.0.0.1:2375"
-	var defaultHOST = "unix:///var/run/docker.sock"
+	var defaultHOST = "unix:///system/volatile/docker/docker.sock"
 
 	if runtime.GOOS == "windows" {
 		defaultHOST = defaultHTTPHost
@@ -34,7 +34,7 @@ func TestParseHost(t *testing.T) {
 		"tcp://192.168:8080":       "tcp://192.168:8080",
 		"tcp://0.0.0.0:1234567890": "tcp://0.0.0.0:1234567890", // yeah it's valid :P
 		"tcp://docker.com:2375":    "tcp://docker.com:2375",
-		"unix://":                  "unix:///var/run/docker.sock", // default unix:// value
+		"unix://":                  "unix:///system/volatile/docker/docker.sock", // default unix:// value
 		"unix://path/to/socket":    "unix://path/to/socket",
 	}
 
diff --git a/opts/hosts_unix.go b/opts/hosts_unix.go
index 611407a..4e231e3 100644
--- a/opts/hosts_unix.go
+++ b/opts/hosts_unix.go
@@ -1,4 +1,4 @@
-// +build !windows
+// +build !windows,!solaris
 
 package opts
 
@@ -6,3 +6,7 @@ import "fmt"
 
 // DefaultHost constant defines the default host string used by docker on other hosts than Windows
 var DefaultHost = fmt.Sprintf("unix://%s", DefaultUnixSocket)
+
+// DefaultUnixSocket Path for the unix socket.
+// Docker daemon by default always listens on the default unix socket
+var DefaultUnixSocket = "/var/run/docker.sock"
